#pragma once
#include "ChatItem.h"
#include "ChatModel.h"
#include "RecentMessageSqlite.h"

#define UM_CHAT_EDIT_FOCUS WM_USER + 1
#define UM_CHAT_EDIT_KILLFOCUS WM_USER + 2

class CChatDlg;
class UIElement;

class CChatMainView
{
public:
	CChatMainView(void);
	CChatMainView(CChatMainView& src);
	virtual ~CChatMainView(void);

	//////////////////////////////////////////////////////////////////////////
	
	//virtual BOOL	CreatePlainView(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID) = 0;
	//virtual BOOL	CreateBubbleView(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID) = 0;
	virtual BOOL    CreateElementList(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, int nDisplayType) { return FALSE; }
	virtual void	InvalidateElement(UIElement* pElement, BOOL bCalcSize){}
	virtual UIElement*	AddChatItem(LPChatItemInfo pChatItemInfo, bool bRestore) = 0;
	virtual void    ShowRecentMessage();
	
	virtual UIElement* AddTranslateFileItem(LPChatItemInfo pChatItemInfo, TranslateFileInfoPtr& pTranslateFileInfo, bool bRestore = true) = 0;
	virtual void	ScrollToChatItem( CChatItem* pChItem ) = 0;
	virtual void	ScrollToLastchatItem() = 0;
		virtual void	DrawSelectedText(BOOL bSelection = TRUE, BOOL bSelectAll = FALSE) = 0;

	//virtual void	UpdateUserStatus(CString strUserId,GTUserStatusType status) = 0;
	virtual HWND	GetChatSafeHwnd() = 0;
	virtual HWND	GetToolTipWindow() = 0; 
	virtual bool	IsGroupRoom() = 0;
	virtual TOOLINFO* GetToolInfo() = 0;
	virtual BOOL	DestroyChatWindow() = 0;
	virtual void	MoveChatWindow(LPCRECT lpRect, BOOL bRepaint = TRUE) = 0;
	virtual CWnd*	GetCWnd() = 0;
	virtual void    SetChatDisplayType(int nType) = 0;
	virtual void	ResetChatItem(UINT uTid){}
	virtual void    UpdateView() = 0;
	virtual void	SetViewSize(SIZE &sz) = 0;
	virtual SIZE	UpdateElementRect(int nIndex) = 0;
	virtual void	UpdateElementStateByIndex(int nIndex) = 0;
	virtual void	UpdateElementStateByPointer(UIElement *e) = 0;
	//////////////////////////////////////////////////////////////////////////
	BOOL			IsExistLastMessage();
	void			EnableLastMessage(BOOL bHaveLastMsg);
	void			SetChatModel(CChatModel* pChatModel);
	void			AddChatItem(CHAT_MSG* pChatMsg);
	CChatDlg*		GetChatDlg()	{ return m_pChatDlg; }
	CChatModel*		GetChatModel()	{ return m_pChatModel; }

	void			SetImgDateBGPath(CString strFileName, int nIndex);
	void			SetImgSysMsgArrow(CString strFileName);
	void			SetImgBGPath(CString strFileName);
	void			SetImgSysMsgBGPath(CString strFileName);
	void			SetImgSendFail(CString strFileName);
	//void			ParseUrlInMsg(CChatItem* pChItem);
	virtual			CSize CalcUIElementRect(){ return CSize(0, 0);}
	virtual			void   UpdateScrollInfo(){}
	virtual CRecentMessageSqlite& GetRecentMessageSqlite() = 0;
	BOOL GetShowRecentMsg(){return m_bShowRecentMsg;};
	void SetShowRecentMsg(BOOL bShowRecentMsg){m_bShowRecentMsg = bShowRecentMsg;};

protected:

	CChatItem*		AllocChatItem(LPChatItemInfo pInfo);
	//BOOL			IsDuplicateSystemMessage(CChatItem* pChItem, CChatItem* pChItemLast, CString strChatMsg);
	BOOL			IsEmptySystemMessage(CChatItem* pChItem, CString strChatMsg);
	Image*			GetStickerImage(CString strStickerID);
	CString			GetImagePath(CString strFileName);
	

	CChatDlg*		m_pChatDlg;
	CChatModel*		m_pChatModel;

	Image*			m_pImgBG;
	Image*			m_pImgDateBG[3];
	Image*			m_pImgSysMsgBG;
	Image*			m_pImgSysMsgArrow;
	Image*			m_pImgSendFail;

	HCURSOR			m_hLinkCursor;		// Cursor for hyperlink
	HCURSOR			m_hIbeamCursor;

	int				m_nCursor;
	BOOL			m_bShowRecentMsg;
	BOOL			m_bHaveLastMsg;
	CSize			m_szTotalViewSize;
private:
	CChatMainView& operator=(const CChatMainView& src)	{ return *this; } //lint !e1529

};
